<template>
  <AppAbstractPage :breadcrumbs="breadcrumbs">
    <AppSearch
      slot="abstractPage-search"
      class="_on-page"/>

    <div
      slot="heading"
      class="pageHeading">
      <div class="pageHeading-basic">
        <h1 class="heading _h1">
          Что ищут {{ currentLocation }} прямо сейчас
        </h1>
      </div>
      <div class="pageHeading-additional">
        <ButtonsCallHelper/>
      </div>
    </div>

    <div
      slot="content"
      class="searchByNumber">
      <TopOffersTable :grid="grid" />
    </div>
  </AppAbstractPage>
</template>

<script>
import { mapState } from 'vuex';

import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/poisk-po-nomeru/index';

import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import AppSearch from '~/components/redesign/app-search/app-search';
import ButtonsCallHelper from '~/components/redesign/app-buttons/buttons-call-helper';
import AppSelect from '~/components/redesign/app-select/app-select';
import TopOffersTable from '~/components/redesign/app-table/top-offers';

export default {
  name: 'MainSearch',
  components: {
    AppAbstractPage,
    ButtonsCallHelper,
    AppSearch,
    AppSelect,
    TopOffersTable,
  },
  mixins: [SeoMixin, SeoPageMixin],
  async asyncData({ app, error }) {
    try {
      const { data } = { ...await app.$axios.$get('/_main/part/getLastRequested') };
      return {
        grid: {
          data,
        },
      };
    } catch (e) {
      console.error(e);
      error({ statusCode: 500 });
    }
    return {};
  },
  data() {
    return {
      breadcrumbs: [
        {
          url: '',
          name: 'Поиск по номеру',
        },
      ],
    };
  },
  computed: {
    ...mapState(['location']),
    currentLocation() {
      return this.location.id
        ? `в ${this.location.prepositionalName}`
        : 'во всех странах';
    },
  },
  watch: {
    async 'location.id'(newValue, oldValue) {
      if (newValue !== oldValue) {
        try {
          const { data } = await this.$axios.$get('/_main/part/getLastRequested');
          this.grid = {
            data,
          };
        } catch (e) {
          console.error(e);
        }
      }
    },
  },
};

</script>

<style lang="postcss">
  /* autoprefixer: off */
  .pageHeading {
    display: flex;
    justify-content: space-between;

    &-basic {
      display: block;
    }

    &-additional {
      display: inline-flex;
      align-items: flex-end;
      margin-top: -1rem;
    }

    .buttonsCallHelper {
      margin-left: 2rem;
    }


    @media screen and (max-width: 1200px) {
      .buttonsCallHelper {
        display: none;
      }
    }
    @media screen and (max-width: 980px) {
      flex-direction: column;

      &-additional {
        margin: 0 auto;
        width: 100%;
      }
    }
  }

  .searchByNumber {
    display: block;
    padding-bottom: 4rem;
  }
</style>
